@layer theme, base, components;

@layer theme {
  :root {
    --background-blue: #679bda;
    --background-white: #f3f5f4;
    --border-gray: #ece4e9;
    --decor-black: #000;
    --encouraging-emerald-bg: #47ba82;
    --encouraging-emerald-hover: #87fac2;
    --encouraging-emerald: #67daa2;
    --link-blue: #3451B2;
    --link-hover-blue: #5471D2;
    --link-visited-purple: #5634B2;
    --shadow-black: #0000003d;
    --shadow-gray: #888;
    --sorting-gray: #ece4e9;
    --sorting-gray-hover: #fdf5fa;
    --sorting-gray-text-hover: #555;
    --sorting-gray-active: #888;
    --text-black: #000;
    --widget-background-white: #fff8f7;
    --widget-border-blue: #31435b;
    --widget-title-background-white: #eee6eb;
    --active-yellow: #FED766;

    background: var( --background-blue ) no-repeat;
    font-size: 100%;
    line-height: normal;
  }

  * {
    margin: 0;
    padding: 0;
    box-sizing: border-box;
    border-width: 0;
    font-family: 'Atkinson Hyperlegible', ui-sans-serif, sans-serif;
    font-weight: 400;
    font-size: 1.05rem;
    line-height: 1.35rem;
  }

  p {
    margin-bottom: 1rem;
  }

  ul {
    list-style-type: disc;
  }

  ol {
    list-style-type: decimal;
  }

  ul, ol {
    padding-left: 1rem;
    margin-top: 0.75rem;
    margin-bottom: 0.75rem;
  }

  a {
    color: var( --link-blue );
    background: transparent;
    padding: 2px;
  }

  a:visited {
    color: var( --link-visited-purple );
  }

  a:hover {
    text-decoration-thickness: 2px;
  }

  a:active {
    background-color: var( --active-yellow );
    outline: solid var( --decor-black ) 2px;
    border-radius: 0.15rem;
    color: var( --text-black )
  }
}

@layer base {
  .app {
    display: flex;
    height: 100vh;
    flex-direction: column;
  }

  main {
    margin-bottom: auto;
  }

  footer {
    background-color: var( --background-white );
    font-size: 0.8rem;
    line-height: 1rem;
    text-align: center;
  }

  footer p {
    margin-top: 0.15rem;
    margin-bottom: 0.15rem;
  }

  input {
    padding: 0.5rem;
    height: 3rem;
    border-radius: 0.25rem;
  }

}

@layer components {
  .nav {
    background-color: var( --background-white );
    display: flex;
    align-items: center;
    flex-flow: column wrap;
    padding: 0.5rem;
    box-shadow: var( --shadow-black ) 0 3px 8px;
  }

  .language-link {
    text-decoration-line: none;
    color: var( --decor-black );

  }

  .language-link:hover {
    text-decoration-line: underline;
    text-decoration-thickness: 2px;
  }

  .btn {
    position: relative;
    top: -2px;
    cursor: pointer;
    border-radius: 0.375rem;
    border-width: 2px;
    border-color: var( --decor-black );
    color: var( --text-black );
    text-decoration-line: none;
    background-color: var( --encouraging-emerald);
    padding: 0.625rem 1.25rem;
    text-align: center;
    font-weight: 700;
    outline: none;
    box-shadow: 0 2px 0 0 var( --shadow-gray );
    border-style: solid;
  }

  .btn:hover {
    background-color: var( --encouraging-emerald-hover);
  }

  .btn:active {
    top: unset;
    box-shadow: unset;
    background-color: var( --active-yellow );
  }

  .sorting-buttons {
    display: inline-block;
  }

  .sorting-buttons button {
    background-color: var( --sorting-gray);
    border-color: var( --decor-black );
    border-radius: 0.250rem;
    border-style: solid;
    border-width: 2px;
    box-shadow: 0 2px 0 0 var( --shadow-gray );
    color: var( --text-black );
    cursor: pointer;
    margin-left: 0.1rem;
    outline: none;
    padding: 0.170rem 0.75rem;
    position: relative;
    text-decoration-line: none;
    top: -2px;
  }

  .sorting-buttons button:hover {
    background-color: var( --sorting-gray-hover);
   }

  .sorting-buttons button:active {
    top: unset;
    background-color: var( --active-yellow );
  }

  .card {
    align-items: center;
    background-color: var( --background-white );
    margin: 0.4rem auto;
    padding: 0.5rem;
    display: flex;
    flex-direction: column;
    max-width: 100%;
    box-shadow: var( --shadow-black ) 0 3px 8px;
    border-radius: 4px;
  }

  .card h2 {
    font-size: 120%;
    margin-bottom: 0.5rem;
    font-weight: 700;
  }

  .card p {
    height: 4rem;
    padding-top: 1rem;
    padding-bottom: 1rem;
  }

  .card form {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    min-width: 100%;
    max-width: max-content;
  }

  .card form input {
    border-radius: 0.25rem;
    border-width: 2px;
    border-color: var( --decor-black );
    border-style: solid;
    min-width: 80%;
  }

  .card form input, label {
    margin-bottom: 1rem;
  }

  .card form input:focus {
    outline: 4px solid var( --active-yellow );
  }

  .pagepile-container {
      padding-top: 1rem;
      padding-bottom: 1rem;
      max-width: 100%;
      min-width: 100%;
      text-overflow: ellipsis;
      overflow: hidden;
  }

  .pagepile-container p {
    padding: 0;
    height: unset;
    margin-bottom: 0.125rem;
  }

  #pile-content {
    max-width: none;
  }

  .pile-content-question {
    width: 100%;
    display: flex;
    align-items: center;
    justify-content: center;
    flex-direction: column;
  }

  .pile-content-question > p {
    margin-bottom: 1rem;
  }

  .pile-content-list {
    max-width: max-content;
    text-overflow: ellipsis;
    overflow-x: auto;
  }

  .widget {
    max-height: calc(324px + 24rem);
    display: flex;
    flex-direction: column;
    overflow: auto;
    border-width: 2px;
    border-color: var( --widget-border-blue );
    border-style: solid;
    border-radius: 0.2rem;
    background-color: var( --widget-background-white );
    box-shadow: var( --shadow-black ) 0 1px 2px;
  }

  .widget p {
    margin: 0 1rem;
  }

  .chart-container {
    overflow-x: auto;
    padding: 0 0.2rem;
    min-height: 324px;
  }

  .chart-box svg {
    margin: auto;
    display: flex;
  }

  .home {
    margin-inline-start: 1rem;
    color: var( --text-black);
    font-weight: 700;
    text-decoration-line: none;
  }

  .home:hover {
    text-decoration-line: underline;
    text-decoration-thickness: 2px;
  }

  .card form .invisible {
    visibility: hidden;
    width: 0;
    height: 0;
    padding: 0;
    margin: 0;
  }

  .grid {
    display: grid;
    grid-template-columns: repeat(1, minmax(0, 1fr));
    gap: 0.5rem;
    width: 100%;
  }

  .title {
    background-color: var( --widget-title-background-white );
    min-height: min-content;
    margin-bottom: 0.2rem;
    padding: 0.2rem;
  }

  .title h3 {
    font-size: 110%;
    font-weight: 500;
    margin: 0.5rem;
  }

  .table-container {
    overflow-y: auto;
    padding: 0.2rem;
  }

  .table-container table {
    width: 100%;
    text-indent: 0;
    border-collapse: collapse;
    border-style: solid;
    border-width: 1px;
    border-color: var( --border-gray );
  }

  .table-container table td, th {
    border-width: 1px;
    border-color: var( --border-gray );
    border-style: solid;
    min-width: 148px;
    width: 50%;
    padding: 1px 2px;
  }

  .table-container table th {
    font-weight: 700;
  }

  .backlink {
    position: relative;
    top: -0.42rem;
  }

  .backlink:active {
    top: -0.20rem;
  }
}

@media screen and (width >= 768px) {
  @layer theme {
    * {
      font-size: 1.15rem;
      line-height: 1.6rem;
    }

    ul, ol {
      padding-left: 2rem;
    }
  }

  @layer components {
    .nav {
      justify-content: space-between;
      flex-flow: row nowrap;
      align-items: unset;
    }

    .language-link {
      margin-inline-end: 1rem;
    }

    .card {
      max-width: 96vw;
      padding: 1rem;
      margin: 1rem auto;
    }

    .card form {
      flex-direction: row;
    }

    .card form input,label {
      margin-bottom: 0;
      margin-inline-end: 2rem;
      margin-top: 0;
    }

    .card form input {
      font-size: 100%;
      min-width: unset;
    }

    .card h2 {
      margin-bottom: 0.8rem;
    }

    .btn {
      font-size: 100%;
      min-width: unset;
    }

    .card form .invisible {
      visibility: hidden;
      width: 0;
      height: 0;
      padding: 0;
      margin: 0;
    }

    .backlink {
      top: -0.52rem;
    }

    .backlink:active {
      top: -0.38rem;
    }
  }
}

@media screen and (width >= 1024px) {
  @layer theme {
    * {
      font-size: 1.25rem;
      line-height: 1.75rem;
    }

    ul, ol {
      padding-left: 3rem;
    }
  }

  @layer components {
    .sorting-buttons button {
      background-color: unset;
      border: unset;
      box-shadow: unset;
      cursor: pointer;
      font-size: small;
      margin-left: 0.1rem;
      padding: 0.05rem 0.1rem;
      position: relative;
      top: -1px;
    }

    .sorting-buttons button:hover {
      background-color: unset;
      color: var( --sorting-gray-text-hover );
    }

    .sorting-buttons button:active {
      top: unset;
      background-color: unset;
      color: var( --sorting-gray-active );
    }

    .card {
      max-width:96vw;
      padding: 1.6rem;
      margin: 1.6rem auto;
    }

    .card form .invisible {
      visibility: hidden;
      width: 0;
      height: 0;
      padding: 0;
      margin: 0;
    }

    .card h2 {
      margin-bottom: 1.4rem;
    }

    .grid {
      grid-template-columns: repeat(2, minmax(0, 1fr));
    }

    .backlink {
      top: -1rem;
    }

    .backlink:active {
      top: -0.88rem;
    }

    .chart-container {
      min-height: 332px;
    }
  }
}

@media screen and (width >= 1590px) {
  @layer theme {
    * {
      font-size: 1.25rem;
      line-height: 1.75rem;
    }
  }

  @layer components {
    .card {
      max-width: 94vw;
    }

    .card form .invisible {
      visibility: hidden;
      width: 0;
      height: 0;
      padding: 0;
      margin: 0;
    }

    .pagepile-container {
      max-width: 66%;
      min-width: 66%;
      display: flex;
      justify-content: center;
  }
  }
}
